/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/10/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.DepartemenDto;
import com.portofolio.service.DepartemenService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;


@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/departemen")
public class DepartemenController extends LocaleController {
    @Lazy
	@Autowired
    private DepartemenService departemenService;
    
    
    @ApiOperation("Api Untuk Menyimpan Departemen")
    @PostMapping("/save")
    public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody DepartemenDto entity,HttpServletRequest request) {
        Map<String, Object> result = departemenService.save(entity);
        return RestUtil.getJsonResponse(result);
    }
    
    @ApiOperation("Api Untuk Update Departemen")
    @PutMapping("/update")
    public ResponseEntity<Map<String, Object>> update(
    		@RequestParam(value = "kdDepartemen", required = true) String kdDepartemen,
    		@RequestParam(value = "version", required = true) Integer version,
    		@Valid @RequestBody DepartemenDto entity, HttpServletRequest request) {
        Map<String, Object> result = departemenService.update(entity,kdDepartemen,version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menghapus Departemen Berdasarkan KdDepartemen")
    @DeleteMapping("/delete")
    public ResponseEntity<Map<String, Object>> deleteById(
    		@RequestParam(value = "kdDepartemen", required = true) String kdDepartemen,
    		@RequestParam(value = "version", required = true) Integer version
    		) {
        Map<String, Object> result = departemenService.deleteById(kdDepartemen, version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan Semua Departemen")
    @GetMapping("/grid")
    public ResponseEntity<Map<String, Object>> grid(
    		@RequestParam(value = "page", defaultValue = "1") Integer page, 
    		@RequestParam(value = "rows", defaultValue = "10") Integer rows,			
    		@RequestParam(value = "dir", defaultValue = "namaDepartemen") String dir,			
    		@RequestParam(value = "sort", defaultValue = "desc") String sort,			
    		@RequestParam(value = "namaDepartemen", required = false) String namaDepartemen,
    		@RequestParam(value = "statusEnabled", required = true) boolean statusEnabled) {
        Map<String, Object> result = departemenService.grid(page, rows, sort, dir, namaDepartemen,statusEnabled);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan Departemen Berdasarkan kdDepartemen")
    @GetMapping("/findByKdDepartemen")
    public ResponseEntity<Map<String, Object>> findByKdDepartemen(
    		@RequestParam(value = "kdDepartemen", required = true) String kdDepartemen, 
    		HttpServletRequest request) {
        Map<String, Object> result = departemenService.findByKdDepartemen(kdDepartemen);
        return RestUtil.getJsonResponse(result);
    }


}
